import java.util.*;

/**
 *Clase que representa una agenda telefónica
 */
public class AgendaTelefonica
{
    // la agenda se guarda en un mapa
    private Map<String,Integer> agenda;
    
    /**
     * Constructor que deja el diccionario vacio
     */
    public AgendaTelefonica()
    {
        agenda = new HashMap<String,Integer>();
    }

    /**
     * Añadir un nombre con su numero de telefono
     */
    public void anadeTelefono(String nombre, int telefono)
    {
        agenda.put(nombre,new Integer(telefono));
    }
    
    /**
     * Consultar un nombre; retorna el telefono,
     * o 0 si el nombre no existe
     */
    public int consulta (String nombre) {
        Integer tel= agenda.get(nombre);
        if (tel==null) {
            return 0;
        } else {
            return tel.intValue();   
        }
    }
    
    /**
     * Saber si un nombre esta en la agenda
     */
    public boolean estaIncluido(String nombre) {
        return agenda.containsKey(nombre);
    }
    
    /**
     * Mostrar la lista de toda la agenda
     */
    public void mostrarNumeros() {
        Set<Map.Entry<String,Integer>> lista=agenda.entrySet();
        System.out.println();
        System.out.println("Nombre - Telefono:");
        for (Map.Entry<String,Integer> e:lista) {
            System.out.println(e.getKey()+" - "+e.getValue());
        }
    }
}
