import java.util.*;
/**
 * Write a description of class ServicioColaMultiple here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class ServicioColaMultiple extends Servicio
{
    // atributos
    private ColaEspera[] fila;
    private long[] horaDisponible; //milisegundos

    /**
     * Constructor al que se le pasa el numero de ventanillas
     * el tiempo mínimo de atención, y el tiempo máximo de atención
     */
    public ServicioColaMultiple(int numVentanillas, int tmin, int tmax)
    {
        this.num=numVentanillas;
        this.tmin=tmin;
        this.tmax=tmax;
        fila = new ColaEspera[num];
        horaDisponible=new long[num];
        long ahora=Reloj.ahora();
        for (int i=0; i<numVentanillas; i++) {
            fila[i]=new ColaEspera();   
            horaDisponible[i]=ahora;
        }
    }

    /**
     * Llegada de un cliente
     */
    public void nuevoCliente(Cliente c) {
        // buscar la cola con menos clientes 
        int min=Integer.MAX_VALUE;
        int pos=-1;
        for (int i=0; i<num; i++) {
            int tamano=fila[i].numClientesEnEspera();
            if (tamano<min) {
                min=tamano;
                pos=i;
            }
        }
        // meter el cliente en esa cola
        fila[pos].nuevoCliente(c);
    }
    
    /**
     * Atiende a los clientes cuando les toca
     */
    public void atiendeClientes()
    {
        long ahora=Reloj.ahora();
        for (int i=0; i<num; i++) {
            if (horaDisponible[i]<=ahora) {
                try {
                    Cliente c=fila[i].atenderCliente();
                    System.out.println("Atendido: "+c);
                    // Calculamos el tiempo de atención
                    double tiempoAtencion=Math.random()*(tmax-tmin)+tmin;
                    horaDisponible[i]=ahora+(long) Math.round(tiempoAtencion);
                } catch (NoSuchElementException e) {
                    // no hacemos nada si no hay nadie esperando
                }
            }
        }
    }
    
    /**
     * Muestra estado
     */
    public void muestraEstado() {
        System.out.println();
        System.out.println("----------Estado Servicio---------");
        System.out.println("Fila NumClientes T. Espera T. Atendidos Max Tiempo");
        for (int i=0; i<num; i++) {
            System.out.printf(" %3d   %3d         %7.2f   %7.2f   %7.2f%n",
                              i,fila[i].numClientesEnEspera(),fila[i].tiempoEsperaNoAtendidos(),
                              fila[i].tiempoEsperaAtendidos(), fila[i].tiempoMaxEsperaAtendidos());
        }
        System.out.println();
    }
     
}
