import java.util.*;
/**
 * Write a description of class ServicioColaMultiple here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class ServicioColaUnica extends Servicio
{
    // atributos
    private ColaEspera fila;
    private long[] horaDisponible; //milisegundos

    /**
     * Constructor al que se le pasa el numero de ventanillas
     * el tiempo mínimo de atención, y el tiempo máximo de atención
     */
    public ServicioColaUnica(int numVentanillas, int tmin, int tmax)
    {
        this.num=numVentanillas;
        this.tmin=tmin;
        this.tmax=tmax;
        fila =new ColaEspera();   
        horaDisponible=new long[num];
        long ahora=Reloj.ahora();
        for (int i=0; i<numVentanillas; i++) {
            horaDisponible[i]=ahora;
        }
    }

    /**
     * Llegada de un cliente
     */
    public void nuevoCliente(Cliente c) {
        // meter el cliente en esa cola
        fila.nuevoCliente(c);
    }
    
    /**
     * Cliente atendido
     */
    public void atiendeClientes()
    {
        long ahora=Reloj.ahora();
        for (int i=0; i<num; i++) {
            if (horaDisponible[i]<=ahora) {
                try {
                    Cliente c=fila.atenderCliente();
                    System.out.println("Atendido: "+c);
                    // Calculamos el tiempo de atención
                    double tiempoAtencion=Math.random()*(tmax-tmin)+tmin;
                    horaDisponible[i]=ahora+(long) tiempoAtencion;
                } catch (NoSuchElementException e) {
                    // no hacemos nada si no hay nadie esperando
                }
            }
        }
    }
    
    /**
     * Muestra estado
     */
    public void muestraEstado() {
        System.out.println();
        System.out.println("----------Estado Servicio---------");
        System.out.println("Fila NumClientes T. Espera T. Atendidos Max Tiempo");
        System.out.printf(" %3d   %3d         %7.2f   %7.2f   %7.2f%n",
                          1,fila.numClientesEnEspera(),fila.tiempoEsperaNoAtendidos(),
                          fila.tiempoEsperaAtendidos(), fila.tiempoMaxEsperaAtendidos());
        System.out.println();
    }
     
}
