import java.util.*;

/**
 * Programa de simulación de un servicio de atencion
 * a clientes
 */

public class Simulador
{
    /**
     * programa de prueba
     */

    public static void main(String[] args) {
        
        final int numVentanillas=5;

        Servicio serv=new ServicioColaUnica(numVentanillas,100,8000);
        //Servicio serv=new ServicioColaUnica(numVentanillas,200,8000);
        
        int tiempoMax= 6000000; // milisegundos
        int periodo=100; // milisegundos
        int contadorClientes=0;
        
        int tiempoMaxLlegada=1700;  // milisegundos
        long horaProximaLlegada=Reloj.ahora()+200;   // milisegundos
        
        for (int tiempo=0; tiempo<=tiempoMax; tiempo+=periodo) {
            long ahora=Reloj.ahora();
            // Simulamos la llegada de clientes
            if (horaProximaLlegada<=ahora) {
                contadorClientes++;
                // creamos un cliente simulado y lo metemos en el servicio
                Cliente c=new Cliente("C"+contadorClientes,contadorClientes+600000000);  
                serv.nuevoCliente(c);
                // Calculamos la hora de la proxima llegada
                horaProximaLlegada=horaProximaLlegada+
                    (long) (Math.random()*tiempoMaxLlegada);
            }
            
            // Simulamos la atención a los clientes
            serv.atiendeClientes();
            
            // esperar
            Reloj.avanzaTiempo(periodo);
            
            // cada ciertos tiempo mostrar el estado
            if (tiempo % (periodo*500) ==0) {
                serv.muestraEstado();
            }
        }

        
    }
}
